require "gitcafeapi/version"
require "net/http"
require "json"


module Gitcafeapi

  # Def GitCafe API Version
  $api_ersion = "v1"

  # Def Basic GitCafe API URI
  $basic_url = "https://api.gitcafe.com/api/#{$api_version}"

  # GitCafe Api Class:Account
  class Account

    def self.get_user(account_username)
      @info = Net::HTTP.get(URI("#{$basic_url}/account/#{@account_username}"))


    
  end

  # GitCafe Api Class:Orgs
  class Orgs

    protected

    def get_org(org)
      info = Net::HTTP.get(URI("#{$basic_url}/orgs/#{@org}"))


    end

  end

  # GitCafe Api Class:Projects
  class Projects

    @@project_url = "#{$basic_url}/projects/"

    def self.get_project (owner,project)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}"))


    end

    def get_assignees (owner,project)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}/assignees"))


    end

    def get_collaborators (owner,project)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}/collaborators"))


    end

    def delete_comment (owner,project,id)
      # No need, Not Coding Yet
    end

    def get_commits (owner,project,sha)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}/commits/#{sha}"))


    end

    def get_commits_treeish (owner,project,treeish)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}/commits/#{treeish}"))


    end

    def post_commit_treeish_comments (owner,project,treeish)
      info = Net::HTTP.post (URI("#{@@project_url}/#{@owner}/#{@project}/commits/#{treeish}/comments", "post"))


    end

    def get_commit_treeish_comments(owner,project,treeish)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}/commits/#{treeish}/comments"))


    end

    def get_deploy_keys (owner,project)
      # Useless for now
    end

    def get_deploy_keys (owner,project)
      # Useless for now
    end

    def get_diff (owner,project,base_commit,head_commit)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}/#{base_commit}/#{head_commit}"))


    end

    def get_pulls (owner,project)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}/pulls"))


    end

    def get_pulls_number (owner,project,number)
      info = Net::HTTP.get (URI("#{@@project_url}/#{@owner}/#{@project}/pulls/#{number}"))


    end

    def get_pulls_number_comments (owner,project,number)
      # Useless for now
    end

    def post_pulls_number_comments (owner,project,number)
      # Useless for now
    end

    def get_raw_treeish (owner,project,treeish)
      # Useless for now
    end

    def get_show_treeish (owner,project,treeish)
      # Useless for now
    end

    # Tickets Control, Useless for now

    # Webhooks Control, Useless for now

  end

  # GitCafe Api Class:User
  class User

    public

    @@user_url = "#{$basic_url}/user"

    protected

    def get_user
      info = Net::HTTP.get (URI("#{@@user_url}"))


    end

    def get_folllowers
      info = Net::HTTP.get (URI("#{@@user_url}/followers"))


    end

    def get_followings
      info = Net::HTTP.get (URI("#{@@user_url}/followings"))


    end

    def get_orgs
      info = Net::HTTP.get (URI("#{@@user_url}/orgs"))


    end

    def get_projects
      info = Net::HTTP.get (URI("#{@@user_url}/projects"))


    end

    def get_pulls
      info = Net::HTTP.get (URI("#{@@user_url}/pulls"))


    end

    def get_tickets
      info = Net::HTTP.get (URI("#{@@user_url}/tickets"))


    end

    def get_watching_projects
      info = Net::HTTP.get (URI("#{@@user_url}/watching_projects"))


    end

  end

  # GitCafe Api Class:Users
  class Users

    public

    @@users_url = "#{$basic_url}/users"

    protected

    def get_username (username)
      info = Net::HTTP.get (URI("#{@@users_url}/#{@username}"))


    end

    def get_followers (username)
      info = Net::HTTP.get (URI("#{@@users_url}/#{@username}/followers"))


    end

    def get_followings (username)
      info = Net::HTTP.get (URI("#{@@users_url}/#{@username}/followings"))


    end

    def get_orgs (username)
      info = Net::HTTP.get (URI("#{@@users_url}/#{@username}/orgs"))


    end

    def get_projects (username)
      info = Net::HTTP.get (URI("#{@@users_url}/#{username}/projects"))


    end

    def get_watching_projects (username)
      info = Net::HTTP.get (URI("#{@@users_url}/#{username}/watching_projects"))


    end

  end

end
